# -*- mode: ruby -*-
# vi: set ft=ruby :

Vagrant.configure("2") do |config|

  # Vagrant Box Settings
  config.vm.box = "ubuntu/disco64"
  config.vm.hostname = "microk8s.example.com"


  # Disable automatic box update checking. If you disable this, then
  # boxes will only be checked for updates when the user runs
  # `vagrant box outdated`. This is not recommended.
  # config.vm.box_check_update = false
  
  # Provider Settings
  config.vm.provider "virtualbox" do |vb|
    # Display the VirtualBox GUI when bootinfind . -type f | xargs grep $oldipg the machine
    # vb.gui = true
    vb.name = "ksingle"
    # Customize the amount of memory on the VM:
    vb.memory = "2048"
  end
  
  # Network Settings
  config.vm.network "private_network", ip: "192.168.33.10"

  # config.vm.network "forwarded_port", guest: 80, host: 8080
  # config.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"
  # config.vm.network "public_network"

  # Shared Folders
  config.vm.synced_folder "./sync_folder", "/home/vagrant/workspace/"
  
  # View the documentation for the provider you are using for more
  # information on available options.

  # Provisioning Settings
  # Enable provisioning with a shell script. Additional provisioners such as
  # Puppet, Chef, Ansible, Salt, and Docker are also available. Please see the
  # documentation for more information about their specific syntax and use.
  config.vm.provision "shell", inline: <<-SHELL
    apt-get update
    apt-get -y upgrade
    snap install microk8s --classic
    sudo sed -i 's/^PasswordAuthentication no/PasswordAuthentication yes/' /etc/ssh/sshd_config
    sudo systemctl reload sshd
    echo "kubeadmin" | passwd --stdin root >/dev/null 2>&1
    microk8s.status --wait-ready 
    microk8s.enable dns
    microk8s.enable dashboard
    microk8s.kubectl config view > /home/vagrant/workspace/config
    cd /home/vagrant/workspace
    find . -type f | xargs sed -i "s/127.0.0.1/192.168.33.10/"
    find . -type f | xargs sed -i "s/certificate-authority-data: DATA+OMITTED/insecure-skip-tls-verify: true/"
  SHELL
end
